from django.http import HttpResponse, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from rest_framework.renderers import JSONRenderer
from rest_framework.parsers import JSONParser
from instance.models import Instance
from instance.serializers import InstanceSerializer


def index(request):
    return HttpResponse("Hello, world. You're at the instance index.")

@csrf_exempt
def instance_list(request):
    """
    List all instances, or create a new one.
    """
    if request.method == 'GET':
        instances = Instance.objects.all()
        serializer = InstanceSerializer(instances, many=True)
        return JsonResponse(serializer.data, safe=False)

    elif request.method == 'POST':
        data = JSONParser().parse(request)
        serializer = InstanceSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
            return JsonResponse(serializer.data, status=201)
        return JsonResponse(serializer.errors, status=400)
